---- #########################################################################
---- #                                                                       #
---- # croco mode gyro                        #
---- #                                                                       #
---- #########################################################################

local bitmapscro = {}
local bitmapsgyr = {}
local bitmapsvit = {}

local options = {
    { "croco", SOURCE, 0},
    { "neutral", VALUE, 1,0,1},	 
    { "mode", SOURCE, 0},
	{ "Invert", VALUE, 1,1,4},
    { "gyro", SOURCE, 0},
   }
   
local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getCrocoStatus(wgt)
  local value = getValue(wgt.options.croco)

  if wgt.options.Invert == 1  then
    value = -value
  end
if wgt.options.neutral == 1 then
		if value > -10 then
		return true
		else
		return false
		end
	else
	if value > 10 then
		return true
		else
		return false
		end
	end
end

local function getGyroStatus(wgt)
  local value = getValue(wgt.options.gyro)

  
  if value > 0 then
    return true
  else
    return false
  end
end

local function getVitesseStatus(wgt)
  local value = getValue(wgt.options.mode)
  
 if wgt.options.Invert == 1 or wgt.options.Invert == 2  then
    value = -value
  end
  
   if value < -10 then
  value = -1
  elseif value > 10 then
  value = 1
  else
    value = 0
  end
  return value
end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
 
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  local statuscroco = getCrocoStatus(wgt)
  local statusgyro = getGyroStatus(wgt)
  local statusvitesse = getVitesseStatus(wgt)
  
  if bitmapscro[0] == nil then
    bitmapscro[0] = Bitmap.open("/WIDGETS/crogivi/crocoOFF50.png")
    bitmapscro[1] = Bitmap.open("/WIDGETS/crogivi/crocoON50.png")
	bitmapsvit[0] = Bitmap.open("/WIDGETS/crogivi/tornade50.png")
	bitmapsvit[1] = Bitmap.open("/WIDGETS/crogivi/relax50.png")
	bitmapsvit[2] = Bitmap.open("/WIDGETS/crogivi/vitesse50.png")
	bitmapsgyr[0] = Bitmap.open("/WIDGETS/crogivi/gyrooff50.png")
	bitmapsgyr[1] = Bitmap.open("/WIDGETS/crogivi/gyroon50.png")
  end
 
  if statuscroco == true then
    lcd.drawBitmap(bitmapscro[1], wgt.zone.x + 0,wgt.zone.y + 0)
  else
    lcd.drawBitmap(bitmapscro[0], wgt.zone.x + 0,wgt.zone.y + 0)
  end
  
  if statusvitesse == 1 then
    lcd.drawBitmap(bitmapsvit[0], wgt.zone.x + 53,wgt.zone.y + 0)
  elseif statusvitesse == 0 then
    lcd.drawBitmap(bitmapsvit[1], wgt.zone.x + 53,wgt.zone.y + 0)
	else
	lcd.drawBitmap(bitmapsvit[2], wgt.zone.x + 53,wgt.zone.y + 0)
  end
  
   if statusgyro == true then
    lcd.drawBitmap(bitmapsgyr[1], wgt.zone.x + 110,wgt.zone.y + 0)
  else
    lcd.drawBitmap(bitmapsgyr[0], wgt.zone.x + 110,wgt.zone.y + 0)
  end
   -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
      if visu > 10 then 
	lcd.setColor(TEXT_COLOR, BLACK)
	local cro = wgt.options.croco
	local gyro = wgt.options.gyro
	local mode = wgt.options.mode
	lcd.drawSource(wgt.zone.x +10 ,wgt.zone.y +10,cro  ,0) 
	lcd.drawSource(wgt.zone.x +115  ,wgt.zone.y + 10,gyro  ,0) 
	lcd.drawSource(wgt.zone.x +60  ,wgt.zone.y + 10,mode  ,0) 
	lcd.setColor(TEXT_COLOR, BLACK)
	end
	----------------------------------------------------------------------------------------
  
  
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
 -- idem large
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, BLACK)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneXLarge(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="crogivi", options=options, create=create, update=update, background=background, refresh=refresh }
