---- #########################################################################
---- #dualexpo#
---- #                                                                       #
---- #########################################################################

local Bitmaps30 = {}
local Bitmaps40 = {}
local valeurs = 0
  

local options = {
  { "TextColor", COLOR, RED },
  { "switch_dualrate", SOURCE, 0},
 }

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
  local value = getValue(wgt.options.switch_dualrate)

  if wgt.options.Invert == 1 then
    value = -value 
  end

  if value < -10 then
  value = -1
  elseif value > 10 then
  value = 1
  else
    value = 0
  end
  return value
end


-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
  ------------------------------------------------------------
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
   local status = getArmedStatus(wgt)
   lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)
   lcd.drawRectangle(wgt.zone.x -0, wgt.zone.y + 0, 160, 80, WHITE, 1)
   lcd.drawText(wgt.zone.x +5, wgt.zone.y + 20, "Ail", 0 + BLACK)
   lcd.drawText(wgt.zone.x +5, wgt.zone.y + 40, "Prf", 0 + BLACK)
   lcd.drawText(wgt.zone.x +5, wgt.zone.y + 60, "Der", 0 + BLACK)
   
   lcd.drawText(wgt.zone.x + 55, wgt.zone.y + 0, "Ratio", 0 + BLACK)
   lcd.drawText(wgt.zone.x + 110, wgt.zone.y + 0, "Expo", 0 + BLACK)
   
   
   local GV1 = getValue('gvar1')
   local GV2 = getValue('gvar2')
   local GV3 = getValue('gvar3')
   local GV4 = getValue('gvar4')
   local GV5 = getValue('gvar5')
   local GV6 = getValue('gvar6')
   
  lcd.setColor(TEXT_COLOR, wgt.options.TextColor)
	lcd.drawText(wgt.zone.x +65 ,wgt.zone.y +20,GV1,0 + TEXT_COLOR) 
    lcd.drawText(wgt.zone.x +115 ,wgt.zone.y +20,GV4,0 + TEXT_COLOR) 
    lcd.drawText(wgt.zone.x +65 ,wgt.zone.y +40,GV2,0 + TEXT_COLOR) 
    lcd.drawText(wgt.zone.x +115 ,wgt.zone.y +40,GV5,0 + TEXT_COLOR) 
	lcd.drawText(wgt.zone.x +65 ,wgt.zone.y +60,GV3,0 + TEXT_COLOR) 
    lcd.drawText(wgt.zone.x +115 ,wgt.zone.y +60,GV6,0 + TEXT_COLOR) 
   
   
   
    -----------------------------------------------------------------------------------
	local dualrate = wgt.options.switch_dualrate
	lcd.drawSource(wgt.zone.x + 10 ,wgt.zone.y +2,dualrate  ,0 + BLACK) 
	----------------------------------------------------------------------------------------
  lcd.setColor(TEXT_COLOR, BLACK) 
  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
 
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneXLarge(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="dualexpo", options=options, create=create, update=update, background=background, refresh=refresh }
