---- #########################################################################
---- #flap eng
---- #                                                                       #
---- #########################################################################

local Bitmaps30 = {}
local Bitmaps40 = {}
local valeurs = 0
  

local options = {
  { "TextColor", COLOR, RED },
  { "switch_flap", SOURCE, 0},
  { "Invert", BOOL, 0},
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
  local value = getValue(wgt.options.switch_flap)

  if wgt.options.Invert == 1 then
    value = -value 
  end

  if value < -500 then
  value = -1
  elseif value > 500 then
  value = 1
  else
    value = 0
  end
  return value
end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
  local status = getArmedStatus(wgt)
  
  
 
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/flap/flapup50.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/flap/flapmoy50.png")
	Bitmaps30[2] = Bitmap.open("/WIDGETS/flap/flapdn50.png")
  end
 
  if status == 0 then    
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x ,wgt.zone.y )
  elseif status == 1 then
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x ,wgt.zone.y )
  else
	lcd.drawBitmap(Bitmaps30[2], wgt.zone.x ,wgt.zone.y )
  end
  
   -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local flap = wgt.options.switch_flap
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +45 ,wgt.zone.y -1,flap  ,SMLSIZE + TEXT_COLOR) 
	end
	lcd.setColor(TEXT_COLOR, BLACK) 
	----------------------------------------------------------------------------------------
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
   local status = getArmedStatus(wgt)
 
  if Bitmaps30[0] == nil then
   Bitmaps30[0] = Bitmap.open("/WIDGETS/flap/flapup50.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/flap/flapmoy50.png")
	Bitmaps30[2] = Bitmap.open("/WIDGETS/flap/flapdn50.png")
  end
 
  if status == 0 then
    lcd.drawText(wgt.zone.x + 70, wgt.zone.y + 5, "MED ", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x,wgt.zone.y)
  elseif status == 1 then
    lcd.drawText(wgt.zone.x + 70, wgt.zone.y + 5, "UP", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x,wgt.zone.y)
	else
	lcd.drawText(wgt.zone.x + 70, wgt.zone.y + 5, "DOWN", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[2], wgt.zone.x,wgt.zone.y)
  end
    -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local flap = wgt.options.switch_flap
   local reset = wgt.options.Reset_MAX
   if visu > 10 then 
	lcd.drawSource(wgt.zone.x +50 ,wgt.zone.y +30,flap  ,0) 
	end
	----------------------------------------------------------------------------------------
  lcd.setColor(TEXT_COLOR, BLACK) 
  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
 
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneXLarge(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="flap", options=options, create=create, update=update, background=background, refresh=refresh }
